<?php
namespace Ems\portalGestor\Controller;

use Zeedhi\Framework\DTO\{ Request, Response};
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

use EMS\portalGestor\Service\SituacaoFuncionalService;

class SituacaoFuncionalController {

    /** @var SituacaoFuncionalService */
    protected $situacaoFuncionalService;

    public function __construct(
        SituacaoFuncionalService $situacaoFuncionalService
    ) {
        $this->situacaoFuncionalService = $situacaoFuncionalService;
    }

    public function getUltimaSituacaoFuncional(
        Request\Row $request,
        Response $response
    ) {
        try {
            $row = $request->getRow();

            $nrOrg                  = (int) $row['NRORG'];
            $nrVinculo              = (int) $row['NRVINCULOM'];
            $nrperiodoapuracacao    = (int) $row['NRPERIODOAPURACACAO'];

            $ultimaSituacaoFuncional = $this->situacaoFuncionalService->getUltimaSituacaoFuncional($nrOrg, $nrVinculo, $nrperiodoapuracacao);

            $response->addDataSet(new DataSet('data', $ultimaSituacaoFuncional));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function getPeriodosEstabilidade(
        Request\Row $request,
        Response $response
    ) {
        try {
            $row = $request->getRow();

            $nrOrg                  = (int) $row['NRORG'];
            $nrVinculo              = (int) $row['NRVINCULOM'];

            $periodosEstabilidade = $this->situacaoFuncionalService->getPeriodosEstabilidade($nrOrg, $nrVinculo);

            $response->addDataSet(new DataSet('data', $periodosEstabilidade));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

}